if not Watcher then return end
local L = LibStub("AceLocale-3.0"):GetLocale("Watcher")
local C = Watcher.constants

local _next = next

function Watcher:addicon(spellname, spellID)
	C[spellname], _, C[spellname.." Icon"] = GetSpellInfo(spellID)
	C[spellname.." SID"] = spellID
end




function Watcher:Debuff(name, casttime, stack,combo,powerThreshold,  powerReverse, healthThreshold, heatlhReverse) -- basically, dots
	local def = Watcher.defaults.char.spell
	k = C[name]
	k = Watcher:OptionalParams(k,combo,powerThreshold, powerReverse,healthThreshold, healthReverse) -- check what optional parameters need to be added and what the key she be altered to in order to reflect this
	
	def.spellname[k] = C[name]
	def.name[k] = k
	def.icon[k] = C[name.." Icon"]
	def.trackspell[k] = C[name]
	def.typedot[k] =  true -- true if looking for an aura (on caster or target)
	def.stockspell[k] = true
	def.dotthreshold[k] = casttime or 0
	def.countreq[k] = stack or 0
	def.caster[k] = true -- ignore other player's debuffs
	def.spellID[k] = C[name.. " SID"]
end

function Watcher:Buff(buff, name,combo,powerThreshold,  powerReverse, healthThreshold, heatlhReverse) -- buff that can be maintained 100% up
	local def = Watcher.defaults.char.spell
	k = C[name].." for "..C[buff]
	k = Watcher:OptionalParams(k,combo,powerThreshold, powerReverse,healthThreshold, healthReverse) -- check what optional parameters need to be added and what the key she be altered to in order to reflect this

	def.spellname[k] = C[name]
	def.name[k] = k
	def.icon[k] = C[buff.." Icon"]
	def.trackspell[k] = C[buff]
	def.typedot[k] =  true -- true if looking for an aura (on caster or target)
	def.isbuff[k] =  true -- true if %trackspell is an aura on the caster
	def.stockspell[k] = true
	def.spellID[k] = C[name.. " SID"]
end

function Watcher:BuffPerm(name, functorTable) -- buff that doesn't fade
	local def = Watcher.defaults.char.spell
	k = C[name]
	k = Watcher:OptionalParams(k,combo,powerThreshold, powerReverse,healthThreshold, healthReverse) -- check what optional parameters need to be added and what the key she be altered to in order to reflect this
	
	
	def.spellname[k] = C[name]
	def.name[k] = k
	def.icon[k] = C[name.." Icon"]
	def.trackspell[k] = C[name]
	def.typedot[k] =  true -- true if looking for an aura (on caster or target)
	def.isbuff[k] =  true -- true if %trackspell is an aura on the caster
	def.nocd[k] = true -- true if the buff will not fade
	def.stockspell[k] = true
	def.spellID[k] = C[name.. " SID"]
end

function Watcher:Direct(name, combo ,powerThreshold,  powerReverse, healthThreshold, heatlhReverse) -- direct damage and the sort
	local def = Watcher.defaults.char.spell
	k = C[name]
	k = Watcher:OptionalParams(k,combo,powerThreshold, powerReverse,healthThreshold, healthReverse) -- check what optional parameters need to be added and what the key she be altered to in order to reflect this
	def.spellname[k] = C[name]
	def.name[k] = k
	def.icon[k] =  C[name.." Icon"]
	def.stockspell[k] = true -- no idea
	def.spellID[k] = C[name.. " SID"]
end
	

function Watcher:Capitalize(debuff, name,combo,powerThreshold,  powerReverse, healthThreshold, heatlhReverse) -- while %debuff is applied, cast %name
	local def = Watcher.defaults.char.spell
	
	k = C[name].." w/ "..debuff
	k = Watcher:OptionalParams(k,combo,powerThreshold, powerReverse,healthThreshold, healthReverse) -- check what optional parameters need to be added and what the key she be altered to in order to reflect this
	
	def.spellname[k] = C[name]
	def.name[k] = k
	def.icon[k] = C[name.." Icon"]
	def.typedot[k] =  true -- true if looking for an aura (on caster or target)
	def.trackspell[k] = C[debuff]
	def.stockspell[k] = true
	def.caster[k] = true -- ignore other player's debuffs
	def.spellID[k] = C[name.. " SID"]
end

function Watcher:Proc(buff, name,combo,powerThreshold,  powerReverse, healthThreshold, heatlhReverse) -- when %buff is triggered on self, cast %name
	local def = Watcher.defaults.char.spell
	k = C[name].." w/ "..buff
	k = Watcher:OptionalParams(k,combo,powerThreshold,powerReverse,healthThreshold, healthReverse) -- check what optional parameters need to be added and what the key she be altered to in order to reflect this
	
	def.spellname[k] = C[name]
	def.name[k] = k -- sets definition names
	def.icon[k] =  C[name.." Icon"]
	def.trackspell[k] = buff -- which spell to look for
	def.typedot[k] =  true -- true if looking for an aura (on caster or target)
	def.isproc[k] =  true -- true if %trackspell is something that should be shown only when it's there
	def.isbuff[k] =  true -- true if %trackspell is an aura on the caster
	def.stockspell[k] = true
	def.spellID[k] = C[name.. " SID"]
end

function Watcher:Apply(debuff, name, casttime, stack, playercast,combo,powerThreshold, powerReverse, healthThreshold, heatlhReverse) -- when %debuff is desired, cast %name
	local def = Watcher.defaults.char.spell	
	k = debuff
	k = Watcher:OptionalParams(k,combo,powerThreshold,powerReverse,healthThreshold, healthReverse) -- check what optional parameters need to be added and what the key she be altered to in order to reflect this
	def.spellname[k] = C[name]
	def.name[k] = k
	def.icon[k] =  C[debuff.." Icon"]
	def.typedot[k] =  true -- true if looking for an aura (on caster or target)
	def.trackspell[k] = debuff -- which spell to look for
	--def.isproc[k] =  true -- true if %trackspell is something that should be shown only when it's there
	def.stockspell[k] = true -- no idea
	def.dotthreshold[k] = casttime or 0
	def.countreq[k] = stack or 0
	def.caster[k] = playercast or true -- false, if you want to count other players' debuffs; true to require player's casts
	def.spellID[k] = C[name.. " SID"]
end

function Watcher:ABC()
	---
end

function Watcher:ComboCost(k,combo, power, reverse, health, healthReverse)
	local def =	Watcher.defaults.char.spell
	local name
	name = " @ >=".. combo.." points/HP"
	k = k..name
	if power then
		k = Watcher:PowerThreshold(k,power,reverse,health, heatlthReverse)
	elseif (health) then
		k = Watcher:HealthThreshold(k, health, healthReverse)
	end
	def.combocost[k] = combo or 0
	return k
end

function Watcher:PowerThreshold(k, power, reverse, health, healtReverse)
	local def =	Watcher.defaults.char.spell
	local name
	if reverse then
		name = " @ <=".. power.."% power"
	else
		name = " @ >=".. power.."% power"
	end
	k = k..name
	if (health) then
		k = Watcher:HealthThreshold(k, health, healthReverse)
	end
	def.powerthresh[k] = power or 0
	def.negthreshold[k] = reverse or false
	return k
end

function Watcher:HealthThreshold(k, health, reverse)
	local def =	Watcher.defaults.char.spell
	local name 
	if reverse then
		name = " @ <=".. health.."% health"
	else
		if(health) then
		name = " @ >=".. health.."% health"
		end
	end
	k = k..name
	def.healthThreshold[k] = health or 0
	def.negHealthThreshold[k] = reverse or false
	return k
end

function Watcher:OptionalParams(k, combo,powerThreshold, powerReverse, healthThreshold, heatlhReverse)
	if combo then 
		k = Watcher:ComboCost(k, combo,powerThreshold, powerReverse, healthThreshold, heatlhReverse)
	elseif powerThreshold then
		k = Watcher:PowerThreshold(k,powerThreshold, powerReverse, healthThreshold, healthReverse)
	elseif healthThreshold then
		k = Watcher:HealthThreshold(k,healthThreshold, healthReverse)
	end
	return k
end

