if not Watcher then return end

if select(2, UnitClass('player')) ~= "DEATHKNIGHT" then return end

local LBF = LibStub("LibButtonFacade", true)
local L = LibStub("AceLocale-3.0"):GetLocale("Watcher")
local media = LibStub:GetLibrary("LibSharedMedia-3.0");
local C = Watcher.constants
	
-- Blood Icons
Watcher:addicon("Blood Strike", 45902)
Watcher:addicon("Death Strike", 49998)
Watcher:addicon("Pestilence", 50842)
Watcher:addicon("Blood Boil", 48721)
Watcher:addicon("Strangulate", 47476)
Watcher:addicon("Blood Tap", 45529)
Watcher:addicon("Dark Command", 56222)
Watcher:addicon("Death Pact", 48743)
Watcher:addicon("Dark Simulacrum", 77606)
Watcher:addicon("Heart Strike", 55050)
Watcher:addicon("Bone Shield", 49222)
Watcher:addicon("Rune Tap", 48982)
Watcher:addicon("Vampiric Blood", 55233)
Watcher:addicon("Dancing Rune Weapon", 49028)

-- Frost Icons
Watcher:addicon("Icy Touch", 45477)
Watcher:addicon("Frost Fever", 59921)
Watcher:addicon("Mind Freeze", 47528)
Watcher:addicon("Chains of Ice", 45524)
Watcher:addicon("Obliterate", 49020)
Watcher:addicon("Path of Frost", 3714)
Watcher:addicon("Icebound Fortitude", 48792)
Watcher:addicon("Horn of Winter", 57330)
Watcher:addicon("Festering Strike", 85948)
Watcher:addicon("Rune Strike", 56815)
Watcher:addicon("Empower Rune Weapon", 47568)
Watcher:addicon("Frost Strike", 49143)
Watcher:addicon("Lichborne", 49039)
Watcher:addicon("Pillar of Frost", 51271)
Watcher:addicon("Hungering Cold", 49203)
Watcher:addicon("Howling Blast", 49184)

-- Unholy Icons
Watcher:addicon("Death Coil", 47541)
Watcher:addicon("Sudden Doom", 81340)
Watcher:addicon("Death Grip", 49576)
Watcher:addicon("Plague Strike", 45462)
Watcher:addicon("Blood Plague", 59879)
Watcher:addicon("Raise Dead", 46584)
Watcher:addicon("Death and Decay", 43265)
Watcher:addicon("Anti-Magic Shell", 48707)
Watcher:addicon("Raise Ally", 61999)
Watcher:addicon("Army of the Dead", 42650)
Watcher:addicon("Outbreak", 77575)
Watcher:addicon("Necrotic Strike", 73975)
Watcher:addicon("Scourge Strike", 55090)
Watcher:addicon("Unholy Frenzy", 49016)
Watcher:addicon("Anti-Magic Zone", 51052)
Watcher:addicon("Dark Transformation", 63560)
Watcher:addicon("Summon Gargoyle", 49206)

function Watcher:addClassSpells()
	-- Blood Spells and Talents
	Watcher:Direct("Blood Strike")
	Watcher:Direct("Death Strike")
	-- Watcher:Capitalize(C["Blood Plague AND Frost Fever"]. "Pestilence", 30)  Can't be implimented yet, requires tracking 2 debuffs, and minimum time between casts.
	Watcher:Direct("Blood Boil")
	Watcher:Debuff("Strangulate")
	Watcher:Direct("Blood Tap")
	Watcher:Direct("Dark Command")
	Watcher:Direct("Death Pact")
	Watcher:Debuff("Dark Simulacrum")
	Watcher:Direct("Heart Strike")
	Watcher:Buff(C["Bone Shield"], "Bone Shield")
	Watcher:Direct("Rune Tap")
	Watcher:Buff(C["Vampiric Blood"], "Vampiric Blood")
	Watcher:Direct("Dancing Rune Weapon")
	
	-- Frost Spells and Talents
	Watcher:Apply(C["Frost Fever"], "Icy Touch")
	Watcher:Direct("Mind Freeze")
	Watcher:Debuff("Chains of Ice")
	Watcher:Direct("Obliterate")
	Watcher:BuffPerm("Path of Frost")
	Watcher:Buff(C["Icebound Fortitude"], "Icebound Fortitude")
	Watcher:Direct("Horn of Winter")
	Watcher:Buff(C["Horn of Winter"], "Horn of Winter")
	Watcher:Direct("Festering Strike")
	Watcher:Direct("Rune Strike")
	Watcher:Direct("Empower Rune Weapon")
	Watcher:Direct("Frost Strike")
	Watcher:Buff(C["Lichborne"], "Lichborne")
	Watcher:Buff(C["Pillar of Frost"], "Pillar of Frost")
	Watcher:Debuff("Hungering Cold")
	Watcher:Direct("Howling Blast")

	-- Unholy Spells and Talents
	Watcher:Direct("Death Coil")
	Watcher:Proc(C["Sudden Doom"], "Death Coil")
	Watcher:PowerThreshold(100, false, "Death Coil")
	Watcher:Direct("Death Grip")
	Watcher:Apply(C["Blood Plague"], "Plague Strike")
	Watcher:Direct("Raise Dead")
	Watcher:Debuff("Death and Decay")
	Watcher:Buff(C["Anti-Magic Shell"], "Anti-Magic Shell")
	Watcher:Direct("Raise Ally")
	Watcher:Direct("Army of the Dead")
	-- Watcher:Apply(C["Blood Plague AND Frost Fever"]. "Outbreak")  Can't be implimented yet, requires tracking 2 debuffs.
	Watcher:Direct("Necrotic Strike")
	Watcher:Direct("Scourge Strike")
	Watcher:Buff(C["Unholy Frenzy"], "Unholy Frenzy")
	Watcher:Direct("Anti-Magic Zone")
	Watcher:Direct("Dark Transformation")
	Watcher:Direct("Summon Gargoyle")
end