if not Watcher then return end
local L = LibStub("AceLocale-3.0"):GetLocale("Watcher")
local C = Watcher.constants

Watcher.debuffs = {}
Watcher.buffs = {}

--[[
	Still need to sort out how to handle stack count for multiple spell tracking 
		- either count on all auras or only on first
	
]]

-- takes spells from option file and adds them to the priority table
function Watcher:AddSpells()	
	for k,v in pairs(self.db.char.spell.name) do
		Watcher:AddPriorityTable(k)
	end
	Watcher:shortDots()
	Watcher:legacyAuras()
	Watcher:setAuras()
end
	
-- add auras from old dot system to the new version
function Watcher:legacyAuras()
	local def = self.db.char.spell
	if def.typedot[k] then
		def.trackAura[k] = def.typedot[k]
		if def.isbuff[k] then
			def.buffs[k] = def.trackspell[k]
		else
			def.debuffs[k] = def.trackspell[k]
		end
		--table.removekey(def.trackspell, k)
		--table.removekey(def.typedot, k)
		--table.removekey(def.isbuff, k)
	end
end
	
-- This only really applies to Explosive Shot which has a dot which is too short to really track using the usual method
function Watcher:shortDots()
	for k,v in pairs (self.db.char.spell.typeshortdot) do
		if v then
			Watcher.dottime[k] = GetTime() - self.db.char.spell.dotlength[k]
		end
	end
end

function Watcher:setAuras()
	local def = self.db.char.spell
	for k,v in pairs(def.trackAura) do
		if v then
			Watcher:getBuffs(k)
			Watcher:getDebuffs(k)
		end
	end
end

function Watcher:getBuffs(k)
	local def = self.db.char.spell
	Watcher.buffs[k] = Watcher:splitField(def.buffs[k])
end

function Watcher:getDebuffs(k)
	local def = self.db.char.spell
	Watcher.debuffs[k] = Watcher:splitField(def.buffs[k])
end